{% extends "base_navbar.html" %}
{% load static icon %}

{% block navbar_projets %}
    active
{% endblock %}

{% block title %}
    {% if edit %}
        Modifier un projet
    {% else %}
        Créer un projet
    {% endif %}
{% endblock %}

{% block head_css %}
    <link href="{% static 'projet/css/projet.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block content %}
    <header>
        <h1>{% if edit %}Modifier{% else %}Créer{% endif %} un projet</h1>
        <div class="header-content">
            <p>
                {% if edit %}
                    Vous souhaitez modifier votre projet {{ form.nom.value }} ?
                {% else %}
                    Ici, vous pouvez créer votre propre projet !
                {% endif %}
            </p>
        </div>
    </header>

    <div class="container">
        <div class="main">
            <form method="post" {% if not edit %}action="{% url 'ajout_projet' %}"{% endif %}>
                {% csrf_token %}

                <h2 class="title">Détails</h2>

                {% if form.non_field_errors %}
                    <div class="alert alert-danger" role="alert">
                        <ul>
                            {% for error in form.non_field_errors %}
                                <li>{{ error }}</li>
                            {% endfor %}
                        </ul>
                    </div>
                {% endif %}

                {% for field in form.visible_fields %}
                    <div class="form-group row">
                        <div class="col-12">
                            {{ field.label_tag }}

                            {% if field.errors %}
                                <ul>
                                    {% for error in field.errors %}
                                        <li>{{ error }}</li>
                                    {% endfor %}
                                </ul>
                            {% endif %}

                            {{ field }}
                            {% if field.help_text %}
                                <small class="form-text text-muted">{{ field.help_text }}</small>
                            {% endif %}

                        </div>
                    </div>
                {% endfor %}

                {% if edit %}
                    <h2 class="title">Participants</h2>

                    <p>
                        Vous souhaitez modifier les participants votre projet {{ form.nom.value }} ?
                        {% if not user.is_staff %}
                            Attention, en décochant la case "<strong>Admin</strong>" à côté de votre nom, vous ne
                            pourrez plus modifier votre projet.
                            Si vous souhaitez récupérer les droits d'admnistration, merci de demander au bureau de {{ NAME }}
                            à l'adresse <strong>{{ CONTACT_EMAIL }}</strong>.
                        {% endif %}
                    </p>

                    <div id="div-container-participants">
                        {% for participant in projet.participants.all %}
                            <div id="div-participant-{{ forloop.counter }}">
                                <div class="input-group mb-3">
                                    <div class="input-group-prepend">
                                        <button type="button" class="btn btn-outline-secondary" data-toggle="collapse"
                                                data-target="#div-role-participant-{{ forloop.counter }}">
                                            <i class="fa fa-caret-down"></i> Rôle
                                        </button>
                                    </div>
                                    <select class="form-control" id="participant-{{ forloop.counter }}"
                                            name="participant-{{ forloop.counter }}">
                                        {% for membre in membres %}
                                            <option value="{{ membre.id }}"
                                                    {% if participant.utilisateur == membre %}selected{% endif %}>
                                                {{ membre.nomComplet }}
                                            </option>
                                        {% endfor %}
                                    </select>
                                    <div class="input-group-append">
                                        <div class="input-group-text">
                                            <input type="checkbox" {% if participant.admin %}checked{% endif %}
                                                   id="participant-admin-{{ forloop.counter }}"/>
                                            &nbsp; Admin
                                        </div>
                                    </div>
                                </div>

                                <div class="collapse" id="div-role-participant-{{ forloop.counter }}"
                                     style="padding-left: 15px">
                                    {% for role in participant.typeParticipant.all %}
                                        <select class="form-control mb-3"
                                                name="role-participant-{{ forloop.parentloop.counter }}-{{ forloop.counter }}">
                                            {% for type in types %}
                                                <option value="{{ type.id }}" {% if type == role %}selected{% endif %}>
                                                    {{ type }}
                                                </option>
                                            {% endfor %}
                                        </select>
                                    {% endfor %}

                                    <button type="button" onclick="add_role({{ forloop.counter }})"
                                            class="btn btn-outline-dark btn-sm mb-4">
                                        <i class="fas fa-plus-circle"></i> Ajouter un rôle
                                    </button>
                                    <button type="button"
                                            onclick="$('#div-role-participant-{{ forloop.counter }} select').last().remove()"
                                            class="btn btn-outline-danger btn-sm mb-4">
                                        <i class="fa fa-times"></i> Supprimer le dernier rôle
                                    </button>
                                </div>
                            </div>
                        {% empty %}
                            Il n'y a aucun rôle d'attribué à qui que ce soit !
                            Pour commencer, ajoutez un participant, ou attendez qu'un membre s'inscrive.
                        {% endfor %}
                    </div>
                    <button type="button" onclick="add_participant()" class="btn btn-outline-dark mb-4">
                        <i class="fas fa-plus-circle"></i> Ajouter un participant
                    </button>
                    <button type="button" onclick="$('div[id*=\'div-participant-\']').last().remove()"
                            class="btn btn-outline-danger mb-4">
                        <i class="fa fa-times"></i> Supprimer le dernier participant
                    </button>
                {% endif %}

                {% if edit %}
                    <input type="button" class="btn btn-primary form-control" value="Valider"
                           onclick="send_form('{% url 'edit_projet' id_projet %}')"/>
                {% else %}
                    <input type="submit" class="btn btn-primary form-control" value="Valider"/>
                {% endif %}
            </form>
        </div>
    </div>
{% endblock %}

{% block footer_javascript %}
    {# Date time picker #}
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
    <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <script src="{% static 'projet/js/datepicker-fr.js' %}"></script>

    <script type="text/javascript">

        $(function () {
            picker = $('#id_deadlineRendu');
            picker.val('{{ form.deadlineRendu.value|date:'d/m/Y' }}');
            picker.datepicker($.datepicker.regional['fr']);
        });

        {% if edit %}
            function add_role(id_participant) {
                let id = 1;
                if ($('#div-role-participant-' + id_participant + ' select').length)
                    id = parseInt($('#div-role-participant-' + id_participant + ' select').last().attr('name').split('-')[3]) + 1;
                let role = "<select class=\"form-control mb-3\" name=\"role-participant-" + id_participant + "-" + id + "\">"
                    {% for type in types %}
                        + "<option value=\"{{ type.id }}\" "
                        {% if type == role %}
                            +"selected"
                        {% endif %}
                        +">{{ type }}</option>"
                    {% endfor %}
                    + "</select>";
                $('#div-role-participant-' + id_participant).append(role);
                $('#div-role-participant-' + id_participant + ' button').appendTo('#div-role-participant-' + id_participant);
            }

            function add_participant() {
                let id = 1;
                if ($('div[id*="div-participant-"]').length)
                    id = parseInt($('div[id*="div-participant-"]').last().attr('id').split('-')[2]) + 1;
                let participant = '<div id="div-participant-' + id + '"><div class="input-group mb-3\"><div class="input-group-prepend">'
                    + '<button type="button" class="btn btn-outline-secondary" data-toggle="collapse" data-target="#div-role-participant-'
                    + id + '"><i class="fa fa-caret-down"></i> Rôle</button></div>'
                    + '<select class="form-control" id="participant-' + id + '" name="participant-' + id + '">'
                    {% for membre in membres %}
                        +'<option value="{{ membre.id }}">{{ membre.nomComplet }}</option>'
                    {% endfor %}
                    + '</select><div class="input-group-append"><div class="input-group-text"><input type="checkbox"/>&nbsp; '
                    + 'Admin</div></div></div><div class="collapse" id="div-role-participant-' + id + '" style="padding-left: 15px">'
                    + '<button type="button" onclick="add_role(' + id + ')" class="btn btn-outline-dark btn-sm mb-4">'
                    + '<i class="fas fa-plus-circle"></i> Ajouter un rôle</button><button type="button" '
                    + 'onclick="$(\'#div-role-participant-' + id + ' select\').last().remove()" class="btn btn-outline-danger btn-sm mb-4">'
                    + '<i class="fa fa-times"></i> Supprimer le dernier rôle</button></div></div>';
                $('#div-container-participants').append(participant);
            }

            function get_participants() {
                let participants = [];
                $('div[id*="div-participant-"]').each(function (i) {
                    let part_id = i + 1;
                    participants.push({
                        'nom': $('#participant-' + part_id).val(),
                        'admin': $('#participant-admin-' + part_id).is(':checked'),
                        'roles': []
                    });
                    console.log(participants);
                    $('select[name*="role-participant-' + part_id + '-').each(function (j, elem) {
                        participants[part_id - 1]['roles'].push($(elem).val());
                    });
                });
                return participants;
            }

            function send_form(url) {
                $('#{{ form.participants.id_for_label }}').val(JSON.stringify(get_participants()));
                let form = $('form');
                if (form[0].checkValidity()) {
                    form.attr("action", url);
                    form.submit();
                } else form[0].reportValidity();
            }
        {% endif %}
    </script>
{% endblock %}
